package com.mortals.xhx.daemon.task;

import cn.hutool.core.date.DateUtil;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.service.ITask;
import com.mortals.framework.service.ITaskExcuteService;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.LicenseStatusEnum;
import com.mortals.xhx.feign.user.IUserFeign;
import com.mortals.xhx.module.license.model.LicenseEntity;
import com.mortals.xhx.module.license.model.LicenseQuery;
import com.mortals.xhx.module.license.service.LicenseService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnExpression;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * 同步用户,唯一标识为用户名。
 */
@Slf4j
@Service("SyncUserTask")
public class SyncUserTaskImpl implements ITaskExcuteService {

    @Autowired
    private UserService userService;
    @Autowired
    private LicenseService licenseService;


    @Override
    public void excuteTask(ITask task) throws AppException {
        log.info("同步用户任务");
        userService.refreshUser();

        //更新证书有效期
        List<LicenseEntity> licenseEntities = licenseService.find(new LicenseQuery());
        for (LicenseEntity licenseEntity : licenseEntities) {
            Date endTime = licenseEntity.getEndTime();
            if (DateUtil.compare(new Date(), endTime) > 0) {
                licenseEntity.setLicenseStatus(LicenseStatusEnum.过期.getValue());
                licenseService.update(licenseEntity);
            }
        }

    }


    @Override
    public void stopTask(ITask task) throws AppException {

    }


}
